#include <irrlicht.h>
#include <iostream>

using namespace irr;

/* Receptor de eventos de teclado e mouse */

class MasterEventReceiver : public IEventReceiver
{
    public:

	struct SMouseState
	{
		bool LeftButtonDown;
		bool RightButtonDown;
		bool ButtonDown;
		SMouseState() : RightButtonDown(false), LeftButtonDown(false), ButtonDown(false){ }		
	} MouseState;

	virtual bool OnEvent(const SEvent& event)
	{
		if (event.EventType == irr::EET_MOUSE_INPUT_EVENT)
		{
			switch(event.MouseInput.Event)
			{
			case EMIE_LMOUSE_PRESSED_DOWN:
				MouseState.LeftButtonDown = true;
				MouseState.ButtonDown = true;
				break;

			case EMIE_RMOUSE_PRESSED_DOWN:
				MouseState.RightButtonDown = true;
				MouseState.ButtonDown = true;
				break;

			default:
				break;
			}
		}
		else if (event.EventType == irr::EET_KEY_INPUT_EVENT)
            KeyIsDown[event.KeyInput.Key] = event.KeyInput.PressedDown;


		return false;
	}

    virtual bool keyDown(EKEY_CODE keyCode) const
    {
        return KeyIsDown[keyCode];
    }

    
    void resetMouseState()
    {
        MouseState.LeftButtonDown = false;
        MouseState.RightButtonDown = false;
        MouseState.ButtonDown = false;
    }

	const SMouseState & GetMouseState(void) const
	{
		return MouseState;
	}

    MasterEventReceiver()
	{
	    for (u32 i=0; i<KEY_KEY_CODES_COUNT; ++i)
            KeyIsDown[i] = false;
    }
    
    private:
        
        bool KeyIsDown[KEY_KEY_CODES_COUNT];

    
};
